# Redesign

Redesign will redesign a room in a specific style. If the room is empty it won't add many furnitures, use the Furnish mode if you need to add furnitures first.

🦋 **Creativity**: It lets you control how crazy Gepetto will be with your room. The higher the number is, the less it will look like the original photo.

### Endpoint

<mark style="color:green;">`POST`</mark> `https://europe-west1-gepettoai.cloudfunctions.net/v1/redesign`

#### Headers

| Name                                            | Type   | Description         |
| ----------------------------------------------- | ------ | ------------------- |
| Authorization<mark style="color:red;">\*</mark> | String | Bearer {{API\_KEY}} |

#### Request Body

<table><thead><tr><th width="269">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>url<mark style="color:red;">*</mark></td><td>String (Url)</td><td><p>Image URL of the room to be redesigned.</p><p>Ex: <a href="https://theneo-prod-public.s3.amazonaws.com/images-1695201150801.jpg">https://theneo-prod-public.s3.amazonaws.com/images-1695201150801.jpg</a></p></td></tr><tr><td>styleId<mark style="color:red;">*</mark></td><td>String</td><td>The style ID that can be fetched on the <a href="https://docs.gepettoapp.com/endpoints/get-styles">Get Styles </a>endpoint.</td></tr><tr><td>roomId<mark style="color:red;">*</mark></td><td>String</td><td>The room ID that can be fetched on the <a href="https://docs.gepettoapp.com/endpoints/get-rooms">Get Rooms</a> endpoint.</td></tr><tr><td>creativity<mark style="color:red;">*</mark></td><td>Number</td><td><p><mark style="color:red;"><strong>Number between 0 and 30.</strong></mark></p><p></p><p>The creativity tells how much freedom you give the AI. The higher the value is, the less likely the result will look like the original image.</p></td></tr><tr><td>mask</td><td>String (Url)</td><td><p>(Optional but recommended for more precision)</p><p></p><p>Custom mask image URL of the area to préserve or modify<br></p><p>⚠️ The mask should have the same dimension as the base image <code>url</code> parameter.<br><br>If set, <code>preserveWindows</code> <code>preserverWalls</code> <code>preserveCeiling</code> <code>preserveFloor</code> are ignored</p></td></tr><tr><td>preserveWindows</td><td>Boolean (true / false)</td><td>(optional) Will prevent the AI from modifying the existing windowpanes / doors and bay window from the original image.</td></tr><tr><td>preserveWalls</td><td>Boolean (true / false)</td><td>(optional) Will prevent the AI from modifying the walls from the original image.</td></tr><tr><td>preserveCeiling</td><td>Boolean (true / false)</td><td>(optional) Will prevent the AI from modifying the ceiling from the original image.</td></tr><tr><td>preserveFloor</td><td>Boolean (true / false)</td><td>(optional) Will prevent the AI from modifying the floor from the original image.</td></tr><tr><td>webhook</td><td>String</td><td>(optional) Webhook <strong>POST</strong> URL to send the result on completion.<br><br>If not provided, the request will wait for the result.</td></tr></tbody></table>

{% tabs %}
{% tab title="200: OK If webhook is not set" %}

```json
{
  "base64": "<base64 encoded image>",
  "status": "success"
}
```

{% endtab %}

{% tab title="401: Unauthorized " %}

{% endtab %}

{% tab title="400: Bad Request " %}

{% endtab %}

{% tab title="500: Internal Server Error " %}

{% endtab %}

{% tab title="200: OK If webhook is provided" %}

```json
{
  "status": "pending",
  "id": "xxxxxxxxxxxxxx", // You can use that id with Get Job
  "styleId": "your_style",
  "roomId": "your_room",
  "creativity": 14,
  "mode": "redesign"
}
```

{% endtab %}
{% endtabs %}

### Code Examples

{% tabs %}
{% tab title="CURL" %}

```bash
curl --location 'https://europe-west1-gepettoai.cloudfunctions.net/v1/redesign' \
--header 'Authorization: Bearer {{API_KEY}}' \
--header 'Content-Type: application/json' \
--data '{
  "url": "https://theneo-prod-public.s3.amazonaws.com/images-1695201150801.jpg",
  "styleId": "demeures",
  "roomId": "living_room",
  "creativity": 15
}'
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
var myHeaders = new Headers();
myHeaders.append("Authorization", "Bearer {{API_KEY}}");
myHeaders.append("Content-Type", "application/json");

var requestOptions = {
  method: 'POST',
  headers: myHeaders,
  body: JSON.stringify({
    "url": "https://theneo-prod-public.s3.amazonaws.com/images-1695201150801.jpg",
    "styleId": "demeures",
    "roomId": "living_room",
    "creativity": 15
  })
};

const response = await fetch("https://europe-west1-gepettoai.cloudfunctions.net/v1/redesign", requestOptions)
const body = await reponse.json();
console.log(body)
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
import json

url = "https://europe-west1-gepettoai.cloudfunctions.net/v1/redesign"

payload = json.dumps({
  "url": "https://theneo-prod-public.s3.amazonaws.com/images-1695201150801.jpg",
  "styleId": "demeures",
  "roomId": "living_room",
  "creativity": 15
})
headers = {
  'Authorization': 'Bearer {{API_KEY}}',
  'Content-Type': 'application/json'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php
$client = new Client();
$headers = [
  'Authorization' => 'Bearer {{API_KEY}}',
  'Content-Type' => 'application/json'
];
$body = '{
  "url": "https://theneo-prod-public.s3.amazonaws.com/images-1695201150801.jpg",
  "styleId": "demeures",
  "roomId": "living_room",
  "creativity": 15
}';
$request = new Request('POST', 'https://europe-west1-gepettoai.cloudfunctions.net/v1/redesign', $headers, $body);
$res = $client->sendAsync($request)->wait();
echo $res->getBody();

```

{% endtab %}

{% tab title="GO" %}

```go
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io/ioutil"
)

func main() {

  url := "https://europe-west1-gepettoai.cloudfunctions.net/v1/redesign"
  method := "POST"

  payload := strings.NewReader(`{
    "url": "https://theneo-prod-public.s3.amazonaws.com/images-1695201150801.jpg",
    "styleId": "demeures",
    "roomId": "living_room",
    "creativity": 15
}`)

  client := &http.Client {}
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Authorization", "Bearer {{API_KEY}}")
  req.Header.Add("Content-Type", "application/json")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := ioutil.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

{% endtab %}

{% tab title="Ruby" %}

```ruby
require "uri"
require "json"
require "net/http"

url = URI("https://europe-west1-gepettoai.cloudfunctions.net/v1/redesign")

https = Net::HTTP.new(url.host, url.port)
https.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = "Bearer {{API_KEY}}"
request["Content-Type"] = "application/json"
request.body = JSON.dump({
  "url": "https://theneo-prod-public.s3.amazonaws.com/images-1695201150801.jpg",
  "styleId": "demeures",
  "roomId": "living_room",
  "creativity": 15,
})

response = https.request(request)
puts response.read_body

```

{% endtab %}
{% endtabs %}

### Results To Expect

| Before                           | After                                            |
| -------------------------------- | ------------------------------------------------ |
| ![](/files/TOOdQRy9AZxOECIi0GfE) | ![Hausmann Style](/files/IUXBO4PdTFpUK3DTTSEL)   |
|                                  |                                                  |
| ![](/files/8yXMPUttjlx2HpSWcDRf) | ![Cap Ferret style](/files/fZGQVowYm8Ybqng0bdlA) |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.gepettoapp.com/endpoints/redesign.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
